﻿using System;
using System.ComponentModel;
using Wisej.Base;
using Wisej.Core;
using Wisej.Web;

namespace HelloWorld.Controls
{
    public partial class TextBoxExt
        : Wisej.Web.TextBox
    {
        public TextBoxExt()
        {
            InitializeComponent();
        }

        private bool m_bClearTool;

        [Category("DemoCase Category")]
        [Description("")]
        [DefaultValue(true)]
        public bool ClearTool {
            get => m_bClearTool;
            set {
                m_bClearTool = value;
                HandleClearToolState(ClearTool && !ReadOnly);
            }
        }

        private void TextBoxExt_ReadOnlyChanged(object sender, EventArgs e)
        {
            HandleClearToolState(ClearTool && !ReadOnly);
        }

        private Wisej.Web.ToolClickEventHandler m_ehClearTool;
        private Wisej.Web.ComponentTool m_ctClearTool;
        private string m_sClearToolName = "ClearTool";
        private void HandleClearToolState(bool bEnabled)
        {
            if (!bEnabled && m_ctClearTool != null) {
                this.SuspendLayout();
                this.ToolClick -= m_ehClearTool;
                this.Tools.Remove(m_ctClearTool);

                m_ctClearTool.Dispose();

                m_ehClearTool = null;
                m_ctClearTool = null;
                this.ResumeLayout(false);
            } else if (bEnabled && m_ctClearTool == null) {
                this.SuspendLayout();
                m_ehClearTool = new Wisej.Web.ToolClickEventHandler(this.TextBoxExt_ToolClick);
                m_ctClearTool = new Wisej.Web.ComponentTool();
                m_ctClearTool.ImageSource = "tool-clear";
                m_ctClearTool.Name = m_sClearToolName;

                this.Tools.Add(m_ctClearTool);
                this.ToolClick += m_ehClearTool;
                this.ResumeLayout(false);
            } else {
                // ignoring no-op
            }
        }

        private void TextBoxExt_ToolClick(object sender, ToolClickEventArgs e)
        {
            if (e.Tool.Name == m_sClearToolName)
                Clear();
        }
    }
}
